var express = require('express')
var webpack = require('webpack')
var config = require('./webpack.dev.conf')
var proxyMiddleware = require('http-proxy-middleware')
// var httpProxy = require('http-proxy')

var app = express()
var compiler = webpack(config)
// var proxy = httpProxy.createProxyServer()

// Define HTTP proxies to your custom API backend
// https://github.com/chimurai/http-proxy-middleware
// var bendi = 'http://127.0.0.1:8089/manage', fuwu = 'http://36.103.224.217:6300/'
var shaoguan = 'http://119.146.1.106:8300/'
var qtx= 'http://36.103.222.144:6300/'
// var bendi = 'http://220.194.141.253:8600/'
// var bendi = 'http://203.57.101.233:9001'
// var bendi = 'http://172.168.1.11:9001/'
// var bendi = 'http://203.57.101.233:8400/'
// var bendi = 'http://121.36.106.17:8400/'
// var fuwu = 'http://203.57.101.233:9001'
var bendi = 'http://203.57.101.233:8400/'
// var bendi = 'http://119.187.112.234:8400/'
var wode = 'http://203.57.101.233:8400/'
// 192.168.
//  var str = 'http://127.0.0.1:8080/manage', str2 = 'http://192.168.50.199:8300'
// var str = 'http://192.168.10.233:8300', str2 = 'http://192.168.10.14:8300'
var proxyTable = {
  '/rs/logic/exportfile': {
    target: bendi
  },
  '/api': {
    target: 'http://192.168.50.4:8400'

  },
  '/rs/sql/chargeQuery_by_gasproperties': {
    target: 'http://localhost:8084/'
  },
  '/rs/logic/chargeQuery_by_gasproperties_line': {
    target: 'http://localhost:8084/'
  },
  '/files': {
    target: bendi
  },
  // 查找资源服务数据
  '/rs/search': {
    target: bendi
  },
  // 查找资源服务数据
  '/rs/logic/getLogin': {
    target: bendi
  },
  // 查找资源服务数据
  '/rs/logic/getInitData': {
    target: bendi
  },
  '/rs/logic/getSaleInitData': {
    target: bendi
  },
  // 用户登录服务地址
  '/rs/user': {
    target: bendi
  },
  '/rs/path/getParams': {
    target: bendi
  },
  '/rs/data': {
    target: bendi
  },
  '/rs/license': {
    target: bendi
  },
  '/rs/db': {
    target: bendi
  },
  '/excel': {
    target: bendi
  },
  '/rs/config': {
    target: bendi
  },
  '/rs/sql/getLicenseById': {
    target: bendi
  },
  '/rs/report': {
    target: bendi
  },
  '/rs/vue': {
    target: bendi
  },
  '/rs/file': {
    target: bendi
  },
  '/rs/sql/singleTable': {
    target: bendi
  },
  '/rs': {
    target: wode
  }
}

var devMiddleware = require('webpack-dev-middleware')(compiler, {
  publicPath: config.output.publicPath,
  stats: {
    colors: true,
    chunks: false
  }
})

var hotMiddleware = require('webpack-hot-middleware')(compiler)
// force page reload when html-webpack-plugin template changes
compiler.plugin('compilation', function (compilation) {
  compilation.plugin('html-webpack-plugin-after-emit', function (data, cb) {
    hotMiddleware.publish({action: 'reload'})
    cb()
  })
})

// proxy api requests
Object.keys(proxyTable).forEach(function (context) {
  var options = proxyTable[context]
  if (typeof options === 'string') {
    options = {target: options}
  }
  app.use(proxyMiddleware(context, options))
})

// handle fallback for HTML5 history API
app.use(require('connect-history-api-fallback')())
// app.use(function (req, res, next) {
//   res.header('Access-Control-Allow-Origin', '*')
//   res.header('Access-Control-Allow-Headers', 'X-Requested-With')
//   res.header('Access-Control-Allow-Methods', 'PUT, POST, GET,DELETE, OPTIONS')
//   res.header('X-Powered-By', '3,2,1')
//   res.header('Access-Control-Allow-Credentials', 'true')
//   res.header('Content-Type', 'application/json;charset=utf-8')
//   next()
// })

// serve webpack bundle output
app.use(devMiddleware)

// enable hot-reload and state-preserving
// compilation error display
app.use(hotMiddleware)

// serve pure static assets
app.use('/static', express.static('./static'))

// app.all('/rs/*', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:8081/reports'
//   })
// })

// app.all('/rs/*', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:8081/ldap'
//   })
// })
// app.all('/excel/*', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:8081/charge'
//   })
// })

// app.all('/rs/*', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:82/charge'
//   })
// })

// app.all('/*', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:82'
//   })
// })
// app.all('/rs/user', function (req, res) {
//   proxy.web(req, res, {
//     target: 'http://127.0.0.1:82'
//   })
// })

module.exports = app.listen(8015, function (err) {
  if (err) {
    console.log(err)
    return
  }
  console.log('Listening at http://localhost:8015')
})
